package com.dmolinerm.sac.BLL;

import java.io.BufferedInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

import android.content.Context;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.net.Uri;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.dmolinerm.sac.R;
import com.dmolinerm.sac.DAO.SacDatabaseHelper;
import com.dmolinerm.sac.GUI.Constantes;

/**
 * @author David Moliner Mateu
 * Adaptador que rellena el listado de pictos.
 */
public class SacPictoListAdapter extends CursorAdapter{

	public SacPictoListAdapter(Context context, Cursor cursor){
		super(context, cursor, CursorAdapter.FLAG_REGISTER_CONTENT_OBSERVER);
	}

	@Override
	public void bindView(View view, Context context, Cursor cursor) {
		
		ImageView pictoImagen = (ImageView) view.findViewById(R.id.picto_row_imagen);
		ImageView pictoBorde = (ImageView) view.findViewById(R.id.picto_row_borde);
		TextView pictoNombre = (TextView) view.findViewById(R.id.picto_row_nombre);
		
		if (cursor.getInt(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_EMOCION)) > 0){
			pictoBorde.setBackgroundColor(Color.parseColor(Constantes.PICTO_EMOCION_COLOR));
		} else {
			pictoBorde.setBackgroundResource(Constantes.CATEGORIA_COLOR.get(cursor.getString(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_CATEGORIA))));
		}
		
		if (cursor.getInt(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_INTERNO_IMG)) > 0){
		pictoImagen.setImageResource(cursor.getInt(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_IMAGEN)));
		} else {
			try{
			String url = "content://media/external/images/media/" + cursor.getInt(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_IMAGEN));
			InputStream is = context.getContentResolver().openInputStream(Uri.parse(url));
			BufferedInputStream bis = new BufferedInputStream(is);
			Bitmap bitmap = Constantes.resizeImage(BitmapFactory.decodeStream(bis),70,70);
	    	pictoImagen.setImageBitmap(bitmap);
			} catch (FileNotFoundException e){
				e.printStackTrace();
			}
		}
		
		pictoNombre.setText(cursor.getString(cursor.getColumnIndex(SacDatabaseHelper.PICTOS_COLUMN_DESC)));
	}

	@Override
	public View newView(Context context, Cursor cursor, ViewGroup parent) {
		
		LayoutInflater inflater = LayoutInflater.from(parent.getContext());
		View view = inflater.inflate(R.layout.picto_row, parent, false);
		return view;
	}
	
	
}
