package com.dmolinerm.sac.GUI;

import java.io.BufferedInputStream;
import java.io.FileDescriptor;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import android.app.Activity;
import android.content.res.AssetFileDescriptor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.LinearLayout;

import com.dmolinerm.sac.R;
import com.dmolinerm.sac.DAO.*;
import com.dmolinerm.sac.entity.Picto;

/**
 * @author David Moliner Mateu
 * Pantalla que muestra el picto de emocion seleccionado
 * y reproduce la locucin si la hay.
 */
public class EmocionShow extends Activity{

	private Picto picto;
	private SacDatabaseHelper databaseHelper;
	private MediaPlayer mPlayer;
	private String mPathFile = "";
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.emocion_simple);
		
		databaseHelper = new SacDatabaseHelper(this);
		
		ImageView image = (ImageView) findViewById(R.id.emocion_simple_imagen);
		
		// Obtiene los datos del picto que nos pasa la pantalla anterior.
		Bundle bundle = getIntent().getExtras();
		long pictoId = bundle.getLong("id");
		picto = databaseHelper.getPictoById(pictoId); 
		
		mPathFile = getExternalFilesDir("locuciones").getAbsolutePath(); 
		
		if (picto.isInternoImg()){
			// Si es una imagen de las que vienen por defecto en la aplicacin (est en \res)
			image.setImageResource(picto.getImage());
		} else {
			try{
				// Si es una imagen de la galera.
				String url = "content://media/external/images/media/" + picto.getImage();
				InputStream is = getContentResolver().openInputStream(Uri.parse(url));
				BufferedInputStream bis = new BufferedInputStream(is);
				Bitmap bitmap = Constantes.resizeImage(BitmapFactory.decodeStream(bis), 70, 70);
		    	image.setImageBitmap(bitmap);
				} catch (FileNotFoundException e){
					e.printStackTrace();
				}
		}
		
		// Si el picto tiene asignada una locucin la reproduce.
		if (!picto.getLocucion().equalsIgnoreCase("")){
			mPlayer = new MediaPlayer();
	        try {
	        	if (picto.isInternoLoc()){
	        		AssetFileDescriptor afd = getAssets().openFd(picto.getLocucion());
	                FileDescriptor fd = afd.getFileDescriptor();
	                mPlayer.setDataSource(fd, afd.getStartOffset(), afd.getLength());
	                
	        	} else {
	        		String locucion = mPathFile + "/" + picto.getLocucion();
	        		mPlayer.setDataSource(locucion);
	        	}
	            mPlayer.prepare();
	            mPlayer.start();
	        } catch (IOException e) {
	            //Log.e(LOG_TAG, "prepare() failed");
	        }
		}
		
		
		LinearLayout row = (LinearLayout) findViewById(R.id.emocion_simple);
		
		row.setOnClickListener(new OnClickListener() {
			// si pulsamos sobre la imagen, se cierra la pantalla y vuelve a la anterior.
			@Override
			public void onClick(View v) {
				finish();
			}
		});
		
	}


}
