package com.dmolinerm.sac.GUI;

import java.io.BufferedInputStream;
import java.io.FileDescriptor;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import android.app.Activity;
import android.content.Intent;
import android.content.res.AssetFileDescriptor;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.media.MediaPlayer;
import android.media.MediaRecorder;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageView;
import android.widget.Toast;

import com.dmolinerm.sac.R;
import com.dmolinerm.sac.DAO.SacDatabaseHelper;
import com.dmolinerm.sac.R.drawable;
import com.dmolinerm.sac.R.id;
import com.dmolinerm.sac.R.layout;
import com.dmolinerm.sac.R.string;
import com.dmolinerm.sac.entity.Frase;
import com.dmolinerm.sac.entity.Picto;

/**
 * @author David Moliner Mateu
 * Edicin y creacin de frases
 */
public class FraseEditActivity extends Activity{
	private ImageView image1, borde1;
	private ImageView image2, borde2;
	private ImageView image3, borde3;
	private ImageView image4, borde4;
	private CheckBox checkCasa, checkColegio, checkCalle;
	private Button btnGrabar, btnReproducir;
	private Button btnGuardar;
	
	private Frase frase = null;
	
	private boolean recording = false;

	private SacDatabaseHelper databaseHelper;
	private Picto[] pictos = new Picto[4];
	
	private MediaRecorder mRecorder = null;
	private MediaPlayer mPlayer = null;
	public static String mPathFile, mFileName = "";
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.edit_frase);
		
		databaseHelper = new SacDatabaseHelper(this);
		frase = new Frase();
		
		mPathFile = getExternalFilesDir("locuciones").getAbsolutePath();		
		
		image1 = (ImageView) findViewById(R.id.edit_frase_image1);
		borde1 = (ImageView) findViewById(R.id.edit_frase_border1);
		image2 = (ImageView) findViewById(R.id.edit_frase_image2);
		borde2 = (ImageView) findViewById(R.id.edit_frase_border2);
		image3 = (ImageView) findViewById(R.id.edit_frase_image3);
		borde3 = (ImageView) findViewById(R.id.edit_frase_border3);
		image4 = (ImageView) findViewById(R.id.edit_frase_image4);
		borde4 = (ImageView) findViewById(R.id.edit_frase_border4);
		
		checkCasa = (CheckBox) findViewById(R.id.edit_frase_context1);
		checkColegio = (CheckBox) findViewById(R.id.edit_frase_context2);
		checkCalle = (CheckBox) findViewById(R.id.edit_frase_context3);
		
		btnGuardar = (Button) findViewById(R.id.save_frase);
		
		btnGrabar = (Button) findViewById(R.id.BtnGrabar);
		btnGrabar.setOnClickListener(new OnClickListener() {
			// Se pulsa el botn GRABAR/PARAR GRABACION para la locucin
			@Override
			public void onClick(View v) {
				
				recording = !recording;
				if (recording){
					// Comprobamos si la frase ya tiene asignado un identificador de locucin, en ese caso se reutiliza
					// si no lo tiene se genera uno nuevo
					if ((frase.getLocucion().equalsIgnoreCase("")) || frase.isInternoLoc()){
						mFileName = "loc" + databaseHelper.getNextLocucion() + ".3gp";						
					} else {
						mFileName = frase.getLocucion();
					}
					// Cambiamos el aspecto del botn a STOP cuando est grabando
					btnGrabar.setBackgroundResource(R.drawable.blue_button);
					btnGrabar.setText(getResources().getString(R.string.parar));
					mRecorder = new MediaRecorder();
			        mRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
			        mRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
			        mRecorder.setOutputFile(mPathFile + "/" + mFileName);
			        mRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
			        try {
			            mRecorder.prepare();
			        } catch (IOException e) {
			            //Log.e(LOG_TAG, "prepare() failed");
			        }
			        mRecorder.start();
				} else {
					// Si ya est grabadndo, se detiene la grabacin.
					btnGrabar.setBackgroundResource(R.drawable.red_button);
					btnGrabar.setText(getResources().getString(R.string.grabar));
					mRecorder.stop();
			        mRecorder.release();
			        mRecorder = null;
			        frase.setLocucion(mFileName);
			        frase.setInternoLoc(false);
				}
			}
		});
		
		btnReproducir = (Button) findViewById(R.id.BtnReproducir);
		btnReproducir.setOnClickListener(new OnClickListener() {
			// reproduce la locucin grabada.
			@Override
			public void onClick(View v) {
				
				mPlayer = new MediaPlayer();
		        try {
		        	if (frase.isInternoLoc()){
		        		AssetFileDescriptor afd = getAssets().openFd(frase.getLocucion());
		                FileDescriptor fd = afd.getFileDescriptor();
		                mPlayer.setDataSource(fd, afd.getStartOffset(), afd.getLength());
		        	} else {
		        		mPlayer.setDataSource(mPathFile + "/" + mFileName);
		        	}
		            
		            mPlayer.prepare();
		            mPlayer.start();
		        } catch (IOException e) {
		            //Log.e(LOG_TAG, "prepare() failed");
		        }
			}
		});
		
		// Comprobar los contextos asignados a la frase
		checkCasa.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				frase.setCasa(isChecked);
			}
		});
		
		checkCalle.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				frase.setCalle(isChecked);				
			}
		});
		
		checkColegio.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			
			@Override
			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
				frase.setColegio(isChecked);
			}
		});
		
		
		// Se pulsa el botn GUARDAR
		btnGuardar.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// Comprobamos que se ha seleccionado alguna imagen
				if (frase.getPicto1() == null && frase.getPicto2() == null && frase.getPicto3() == null && frase.getPicto4() == null){
					Toast.makeText(getApplicationContext(), getResources().getString(R.string.msg_seleccionar_imagen), Toast.LENGTH_SHORT).show();
				} else if (!checkCasa.isChecked() && !checkCalle.isChecked() && !checkColegio.isChecked()){
					// Comprobamos que se ha seleccionado algn contexto.
					Toast.makeText(getApplicationContext(), getResources().getString(R.string.msg_seleccionar_contexto), Toast.LENGTH_SHORT).show();
				} else {
					databaseHelper.saveFrase(frase);
					FraseEditActivity.this.setResult(RESULT_OK);
					finish();
				}			
			}
		});
		
		// En caso de que estemos editando una frase, aqu obtenemos los datos de la frase que nos pasa la pantall anterior (lista)
		Bundle args = getIntent().getExtras();
		
		if (args != null){
			long pictoId, contextoId;
			int pictoOrder;
			Cursor c = databaseHelper.getPictosFromFrase(args.getLong("frase"));
			if (c.moveToFirst()) {
			     //Recorremos el cursor hasta que no haya ms registros
			     do {
			    	 pictoId = c.getLong(c.getColumnIndex(SacDatabaseHelper.FRASES_PICTOS_COLUMN_PICTO));
			    	 pictoOrder = c.getInt(c.getColumnIndex(SacDatabaseHelper.FRASES_PICTOS_COLUMN_ORDEN));
			    	 
			    	 pictos[pictoOrder-1] = databaseHelper.getPictoById(pictoId);
			    	 switch(c.getInt(c.getColumnIndex(SacDatabaseHelper.FRASES_PICTOS_COLUMN_ORDEN))){
			    	 	case 1: rellenaPicto(borde1, image1, pictos[0]);
			    	 			frase.setPicto1(pictos[0]);
			    	 			break;
			    	 	case 2: rellenaPicto(borde2, image2, pictos[1]);
			    	 			frase.setPicto2(pictos[1]);
			    	 			break;
			    	 	case 3: rellenaPicto(borde3, image3, pictos[2]);
			    	 			frase.setPicto3(pictos[2]);
			    	 			break;
			    	 	case 4: rellenaPicto(borde4, image4, pictos[3]);
			    	 			frase.setPicto4(pictos[3]);
			    	 }		    	 		    	 	
			         
			     } while(c.moveToNext());
			}
			
			c = databaseHelper.getContextosFromFrase(args.getLong("frase"));
			if (c.moveToFirst()){
				do{
					contextoId = c.getLong(c.getColumnIndex(SacDatabaseHelper.FRASES_CONTEXTOS_COLUMN_CONTEXTO));
					if (contextoId == Constantes.CONTEXTO_CALLE_ID){
						frase.setCalle(true);
						checkCalle.setChecked(true);
					}
					if (contextoId == Constantes.CONTEXTO_CASA_ID){
						frase.setCasa(true);
						checkCasa.setChecked(true);
					}
					if (contextoId == Constantes.CONTEXTO_COLEGIO_ID){
						frase.setColegio(true);
						checkColegio.setChecked(true);
					}
				} while (c.moveToNext());
			}
			
			frase.setLocucion(databaseHelper.getLocucionFromFrase(args.getLong("frase")));
			mFileName = frase.getLocucion();
			frase.setInternoLoc(databaseHelper.getIsLocucionFraseInterna(args.getLong("frase")));
			frase.setId(args.getLong("frase"));
			
		}
		
		image1.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				Intent intent = new Intent(v.getContext(), GaleriaPictosActivity.class);
				
				startActivityForResult(intent, Constantes.REQUEST_SELECT_FRASE_IMAGE_1);
			}
		});
		
		image2.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				Intent intent = new Intent(v.getContext(), GaleriaPictosActivity.class);
				
				startActivityForResult(intent, Constantes.REQUEST_SELECT_FRASE_IMAGE_2);
			}
		});
		
		image3.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				Intent intent = new Intent(v.getContext(), GaleriaPictosActivity.class);
				
				startActivityForResult(intent, Constantes.REQUEST_SELECT_FRASE_IMAGE_3);
			}
		});
		
		image4.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				Intent intent = new Intent(v.getContext(), GaleriaPictosActivity.class);
				
				startActivityForResult(intent, Constantes.REQUEST_SELECT_FRASE_IMAGE_4);
			}
		});
	}
	
	
	// Asigna las imgenes seleccionadas en la galera.
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (resultCode == RESULT_OK){
			if (requestCode == Constantes.REQUEST_SELECT_FRASE_IMAGE_1){
				pictos[0] = databaseHelper.getPictoById(data.getLongExtra("picto", 0));
				rellenaPicto(borde1, image1, pictos[0]);
				frase.setPicto1(pictos[0]);
			}
			if (requestCode == Constantes.REQUEST_SELECT_FRASE_IMAGE_2){
				pictos[1] = databaseHelper.getPictoById(data.getLongExtra("picto", 0));
				rellenaPicto(borde2, image2, pictos[1]);
				frase.setPicto2(pictos[1]);
			}
			if (requestCode == Constantes.REQUEST_SELECT_FRASE_IMAGE_3){
				pictos[2] = databaseHelper.getPictoById(data.getLongExtra("picto", 0));
				rellenaPicto(borde3, image3, pictos[2]);
				frase.setPicto3(pictos[2]);
			}
			if (requestCode == Constantes.REQUEST_SELECT_FRASE_IMAGE_4){
				pictos[3] = databaseHelper.getPictoById(data.getLongExtra("picto", 0));
				rellenaPicto(borde4, image4, pictos[3]);
				frase.setPicto4(pictos[3]);
			}
		}
		
		
		
	}


	// Mtodo que forma el picto con la imagen y el color de borde correspondiente.
	private void rellenaPicto(ImageView borde, ImageView image, Picto picto){
		
		if (picto.getSentimiento()){
			borde.setBackgroundColor(Color.parseColor(Constantes.PICTO_EMOCION_COLOR));
		} else {
			borde.setBackgroundResource(Constantes.CATEGORIA_COLOR.get(picto.getCategoria()));
		}
		
		if (picto.isInternoImg()){
			image.setImageResource(picto.getImage());
		} else {
			try{
			String url = "content://media/external/images/media/" + picto.getImage();
			InputStream is = getContentResolver().openInputStream(Uri.parse(url));
			BufferedInputStream bis = new BufferedInputStream(is);
			Bitmap bitmap = Constantes.resizeImage(BitmapFactory.decodeStream(bis), 70, 70);
	    	image.setImageBitmap(bitmap);
			} catch (FileNotFoundException e){
				e.printStackTrace();
			}
		}
	}
	
	
}
