package com.dmolinerm.sac.GUI;

import com.dmolinerm.sac.R;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

/**
 * @author David Moliner Mateu
 * Pantalla principal de la aplicacin.
 */
public class MainActivity extends Activity {
	
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.main_layout);
		
		
		Button mBoton1 = (Button) findViewById(R.id.boton1);
		Button mBoton2 = (Button) findViewById(R.id.boton2);
		Button mBoton3 = (Button) findViewById(R.id.boton3);
		Button mBoton4 = (Button) findViewById(R.id.boton4);
		
		// Corresponde al botn contexto CASA de la pantalla principal
		mBoton1.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				
				// Muestra la lista de frases existentes asignadas al contexto casa
				Intent i = new Intent(v.getContext(), FrasesContextListActivity.class);
				// Pasa como informacin el contexto seleccionado
				i.putExtra("contexto", Constantes.CONTEXTO_CASA_ID);
				startActivity(i);
			}
		});
		
		// Corresponde al botn contexto COLEGIO de la pantalla principal
		mBoton2.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// Muestra la lista de frases existentes asignadas al contexto colegio
				Intent i = new Intent(v.getContext(), FrasesContextListActivity.class);
				// Pasa como informacin el contexto seleccionado
				i.putExtra("contexto", Constantes.CONTEXTO_COLEGIO_ID);
				startActivity(i);
			}
		});
		
		// Corresponde al botn contexto CALLE de la pantalla principal
		mBoton3.setOnClickListener(new OnClickListener() {
	
			@Override
			public void onClick(View v) {
				// Muestra la lista de frases existentes asignadas al contexto calle
				Intent i = new Intent(v.getContext(), FrasesContextListActivity.class);
				// Pasa como informacin el contexto seleccionado
				i.putExtra("contexto", Constantes.CONTEXTO_CALLE_ID);
				startActivity(i);
			}
		});
		
		
		// Corresponde al botn EMOCIONES  de la pantalla principal
		mBoton4.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// Muestra los pictos marcados como expresan emocion
				Intent i = new Intent(v.getContext(), EmocionesListActivity.class);
				
				startActivity(i);
			}
		});
	}


	// Crea el men de acceso a la configuracin en la pantalla principal
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		
		getMenuInflater().inflate(R.menu.menu_config, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		
		Intent i = null;
		
		
		switch (item.getItemId()){
		case R.id.menu_config_pictos: // Configuracin de pictos
			i = new Intent(this, PictoListActivity.class);
			startActivity(i);
			break;
		case R.id.menu_config_sentencias: // Configuracin de frases
			i = new Intent(this,FraseListActivity.class);
			startActivity(i);
			break;
		case R.id.menu_config_about: //Men Acerca De
			i = new Intent(this, AcercaDe.class);
			startActivity(i);
		}
		return true;
	}
	
	
	
	
	


}
