package com.dmolinerm.sac.GUI;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;

import com.dmolinerm.sac.R;
import com.dmolinerm.sac.DAO.SacDatabaseHelper;

/**
 * @author David Moliner Mateu
 * Pantalla de presentacin.
 * Se usa para realizar la carga inicial de datos.
 */
public class Splash extends Activity {

    private final int SPLASH_DISPLAY_LENGHT = 3000; //Duracin de la visualizacin pantalla
    private SacDatabaseHelper databaseHelper;

    
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        setContentView(R.layout.splash_layout);
        
        databaseHelper = new SacDatabaseHelper(this);

        // Tras el lapso configurado anteriormente, lanza la pantalla principal de la operacin
        new Handler().postDelayed(new Runnable(){
            @Override
            public void run() {
                
                Intent mainIntent = new Intent(Splash.this,MainActivity.class);
                Splash.this.startActivity(mainIntent);
                Splash.this.finish();
            }
        }, SPLASH_DISPLAY_LENGHT);
        
        // Realiza la carga de datos por defecto
        // Si la base de datos est vaca.
        
        if (databaseHelper.isPictoVacia()){
        	databaseHelper.inicializaPictos();
        	databaseHelper.inicializaContextos();
        	databaseHelper.cargaContextos();
        	databaseHelper.inicializaFrases();
        	databaseHelper.inicializaContadorLocuciones();
        } else {
        	databaseHelper.cargaContextos();
        }
        
          
        databaseHelper.close();
    }
}
